<template>
  <AppMainCard
    text-root="verify"
    type="success"
  >
    <div
      class="w-full md:w-3/4"
    >
      <VerificationSteps
        :is-credential-valid="isCredentialValid"
      />
    </div>
    <VerificationResultsOverview
      :credential-subject="credentialSubject"
      :policy-report="policyReport"
      :proof="proof"
    />
    <AppFlexCenterLayout column class="gap-5">
      <button
        v-show="isCredentialValid"
        class="btn btn-outline btn-primary w-full font-bold text-primary"
        @click="loginToPortal"
      >
        {{ $t('verify.portal') }}
      </button>
      <button
        class="btn btn-outline btn-primary w-full font-bold text-primary"
        @click="downloadFile"
      >
        {{ $t('verify.download') }}
      </button>
    </AppFlexCenterLayout>
  </AppMainCard>
</template>

<script>
/* eslint-disable camelcase */
import Vue from 'vue'

export default Vue.extend({
  name: 'SuccessPage',
  data() {
    return {
      access_token: 'View session token',
      isCredentialValid: false,
      isValidating: false,
      fail: false,
      data: {},
      policyReport: {
        SignaturePolicy: false,
        ChallengePolicy: false,
        VpTokenClaimPolicy: false
      },
      credentialSubject: {
        hasLegallyBindingName: '',
        hasRegistrationNumber: '',
        hasCountry: '',
        hasJurisdiction: '',
        id: '',
        leiCode: '',
        ethereumAddress: ''
      },
      proof: {
        created: ''
      }
    }
  },
  async created() {
    const { access_token } = this.$route.query
    this.isValidating = true

    if (!access_token) {
      return
    }

    const baseURI = 'https://wallet.lab.gaia-x.eu/verifier-api'

    // eslint-disable-next-line camelcase
    await fetch(`${baseURI}/auth?access_token=${access_token}`)
      .then(response => response.json())
      .then(data => {
        this.isCredentialValid = true
        this.isValidating = false
        this.data = data
        this.credentialSubject = data.vp_token.verifiableCredential[0].credentialSubject
        this.credentialSubject.id = `${this.credentialSubject.id.substring(0, 21)}...`
        this.policyReport = data.verification_result.policyResults
        this.proof = data.vp_token.verifiableCredential[0].proof
      })
      .catch(err => {
        // eslint-disable-next-line no-console
        console.error(err)
      })
  },
  methods: {
    downloadFile() {
      const blob = new Blob([JSON.stringify(this.data, null, 2)], {
        type: 'application/json'
      })
      const url = window.URL.createObjectURL(blob)
      const a = document.createElement('a')
      a.style.display = 'none'
      a.href = url
      a.download = this.generateFilename()
      document.body.appendChild(a)
      a.click()
      window.URL.revokeObjectURL(url)
    },
    generateFilename() {
      const currentDate = new Date()
      const date = `${currentDate.getDate()}-${currentDate.getMonth()}-${currentDate.getFullYear()}`
      const currentMinutes = currentDate.getMinutes()
      const minutes =
        currentMinutes < 10 ? `0${String(currentMinutes)}` : currentMinutes
      const time = `${currentDate.getHours()}-${minutes}`
      return `gaia-x_vc_${time}_${date}.json`
    },
    loginToPortal() {
      const baseURI = 'https://vp-registry.gaiax.delta-dao.com'
      const payload = { vp_token: this.data.vp_token }
      this.$axios.post(`${baseURI}/api/v2/presentation/register`, payload)
        .then(response => {
          window.location.href = `https://portal.minimal-gaia-x.eu/profile?token=${response.data.data.token}`
        })
        .catch(error => {
        // eslint-disable-next-line no-console
          console.error(error)
        })
    }
  }
})
</script>
